"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "core", {
    enumerable: true,
    get: ()=>core
});
const _immutableMapSet = require("immutable-map-set");
const _jsonObjectify = require("json-objectify");
const _serializeWhatever = require("serialize-whatever");
const _messageQueue = require("./message-queue");
const _schedulerEvent = require("./scheduler-event");
const deserializableClasses = [
    _schedulerEvent.SchedulerEventGroup,
    _schedulerEvent.SchedulerEvent,
    _schedulerEvent.SchedulerTarget,
    _messageQueue.MessageQueue,
    _immutableMapSet.ImmSet, 
];
const { replacer , reviver  } = (0, _serializeWhatever.createContext)([
    [
        Float64Array,
        [
            _serializeWhatever.thru,
            _serializeWhatever.thru
        ]
    ],
    [
        Uint8Array,
        [
            _serializeWhatever.thru,
            _serializeWhatever.thru
        ]
    ], 
]);
const { objectify , deobjectify  } = (0, _jsonObjectify.createContext)([
    Float64Array,
    Uint8Array
]);
const core = {
    pickFromLocal: [
        'id',
        'targets',
        'loopPoints'
    ],
    serialize: (data)=>objectify(data, replacer(data)),
    deserialize: (data)=>deobjectify(data, reviver(deserializableClasses))
};

//# sourceMappingURL=scheduler-core.js.map